// OutputCMT.cpp: COutputCMT NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "vjb30030.h"
#include "OutputCMT.h"
#include <ctype.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

COutputCMT::COutputCMT()
{
	int nHAdapter, nScsiID, nScsiLUN;

	m_bLabelCheck = FALSE;

	// INIt@CCMT̐ݒ擾
	nHAdapter = GetIniData("CMT", "HAdapter", 0);
	nScsiID = GetIniData("CMT", "ScsiID", 0);
	nScsiLUN = GetIniData("CMT", "ScsiLUN", 0);
	m_sSystemID = GetIniData("CMT", "SystemID", "HITACVOS3");

	// CMTuI[v
	if (m_MTDriver.Open(nHAdapter, nScsiID, nScsiLUN) == 0)
		m_bOpen = TRUE;
	else
		m_bOpen = FALSE;
}

COutputCMT::~COutputCMT()
{
	// CMTuN[Y
	if (m_bOpen)
		m_MTDriver.Close();
}

//
//	@\	F	{[x`FbN
//
//		F	pQueue - L[
//
//	Al	F	ʃR[h
//
//	@\F	O}̂̃{[x`FbNB
//
//	l	F	
//
int COutputCMT::CheckVolumeName(Queue *pQueue)
{
	// CMTuI[vĂȂ΃G[
	if (!m_bOpen)
		return RC_IOERROR;

	m_bLabelCheck = TRUE;

	return RC_NORMAL;
}

//
//	@\	F	O}̏o͏
//
//		F	pQueue - L[
//
//	Al	F	ʃR[h
//
//	@\F	O}̂Ƀt@Co͂B
//
//	l	F	
//
int COutputCMT::OutputFiles(Queue *pQueue)
{
	HANDLE	hdir;
	WIN32_FIND_DATA	findBuf;
	int i;
	char (*pFileBuf)[LEN_FILENAME];
	int nFileCount;
	CString sVolLabel[MAX_VOLUME_LABEL];
	int nVolLabel;
	int nResult;

	// CMTuI[vĂȂ΃G[
	if (!m_bOpen)
		return RC_IOERROR;

	// J}ŋ؂ꂽ{[x𕪗
	nVolLabel = SplitVolumeLabel(pQueue, sVolLabel);

	// t@C擾t@C`FbN
	nFileCount = 0;
	hdir = FindFirstFile(CreatePathName(m_sSrcDir, "*"), &findBuf);
	if (hdir != INVALID_HANDLE_VALUE) {
		do {
			if (!(findBuf.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
				if (!CheckFileName(findBuf.cFileName)) {
					FindClose(hdir);
					DispMessage(IDS_MSG_ILLEGAL_FILENAME, MB_OK, TRUE, findBuf.cFileName);
					return RC_ILLEGALFILENAME;
				}
				nFileCount++;
			}
		} while (FindNextFile(hdir, &findBuf));

		FindClose(hdir);
	}

	// t@Cobt@m
	pFileBuf = new char[nFileCount][LEN_FILENAME];

	// t@Ct@Cobt@Ɋi[
	i = 0;
	hdir = FindFirstFile(CreatePathName(m_sSrcDir, "*"), &findBuf);
	if (hdir != INVALID_HANDLE_VALUE) {
		do {
			if (!(findBuf.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) {
				strcpy(pFileBuf[i++], findBuf.cFileName);
				if (i >= nFileCount)
					break;
			}
		} while (FindNextFile(hdir, &findBuf));

		FindClose(hdir);
	}

	// t@C "n" Ń\[g
	qsort(pFileBuf, nFileCount, LEN_FILENAME, CompareFileName);

	// CMTݏ
	nResult = WriteCMT(m_sSrcDir, pFileBuf, nFileCount, sVolLabel, nVolLabel);

	// t@Cobt@J
	delete [] pFileBuf;

	return nResult;
}

//
//	@\	F	CMTo͏
//
//		F	sSrcDir - Rs[fBNg
//				pFileBuf - o̓t@Cobt@
//				nFileCount - o̓t@C
//				sVolLabel - {[x
//				nVolLabel - {[x
//
//	Al	F	ʃR[h
//
//	@\F	CMTɃt@Co͂B
//
//	l	F	
//
int COutputCMT::WriteCMT(CString &sSrcDir, char (*pFileBuf)[LEN_FILENAME], int nFileCount, CString *sVolLabel, int nVolLabel)
{
	CString sSrcFile;
	BOOL bBOT;
	CString sReadVolLabel;
	CString sFileID;
	CString sMsg;
	int nRecordLength;
	int nBlockingFactor;
	int nVolCount;
	int i;
	int nResult;

	// CMT݊Jn
	if (m_MTDriver.WriteStart() != 0) {
		return RC_IOERROR;
	}

	// CMTݏ
	bBOT = TRUE;
	nVolCount = 0;
	for (i = 0; i < nFileCount; i++) {
		// t@Ct@CʖAR[hAubNW𕪗
		if (!AnalyzeFileName(pFileBuf[i], &sFileID, &nRecordLength, &nBlockingFactor))
			continue;

		// Rs[t@C̃pX擾
		sSrcFile = CreatePathName(sSrcDir, pFileBuf[i]);

		// Pt@Cݏ
		while (TRUE) {
			if (bBOT) {
				// }̃ZbgbZ[W
				if (nVolCount < nVolLabel) {
					if (DispMessage(IDS_MSG_DEVICE_SET2, MB_OKCANCEL, FALSE,
							"CMT", sVolLabel[nVolCount]) == IDCANCEL)
					return RC_CANCEL;
				} else {
					if (DispMessage(IDS_MSG_DEVICE_SET, MB_OKCANCEL, FALSE,
							"CMT") == IDCANCEL)
					return RC_CANCEL;
				}

				// {[x`FbN
				if (m_bLabelCheck && nVolCount < nVolLabel) {
					while (true) {
						if ((nResult = m_MTDriver.ReadVolumeLabel(sReadVolLabel)) != 0) {
							if (nResult == MT_KEY_NOTREADY) {
								if (DispMessage(IDS_MSG_NOTREADY, MB_RETRYCANCEL, FALSE) == IDCANCEL)
									return RC_CANCEL;
								continue;
							}
							return RC_IOERROR;
						}

						if (sReadVolLabel == "")
							sReadVolLabel = "000000";

						if (sReadVolLabel != sVolLabel[nVolCount]) {
							m_MTDriver.Unload();
							if (DispMessage(IDS_MSG_DIFF_VOLLABEL, MB_RETRYCANCEL, FALSE,
									sReadVolLabel, sVolLabel[nVolCount]) == IDCANCEL) {
								return RC_VOLUMENAME;
							}
						} else
							break;
					}
				}
			}
retry:
			// CMTɃt@C̓e
			if (sVolLabel[0] == "000000")
				nResult = m_MTDriver.WriteFileNonLabel(sSrcFile, nRecordLength, nBlockingFactor);
			else
				nResult = m_MTDriver.WriteFileWithLabel(sSrcFile, sFileID, m_sSystemID, nRecordLength, nBlockingFactor);

			if (nResult < 0) {
				if (nResult == MT_KEY_NOTREADY) {
					if (DispMessage(IDS_MSG_NOTREADY, MB_RETRYCANCEL, FALSE) == IDCANCEL)
						return RC_CANCEL;
					goto retry;
				}
				return RC_IOERROR;
			} else if (nResult == RESULT_FILE_END) {
				// t@CݏI
				bBOT = FALSE;
				break;
			} else if (nResult == RESULT_VOLUME_END) {
				// x̏ꍇA}`t@C^}`{[̓T|[gȂ
				if (sVolLabel[0] == "000000" && nFileCount > 1)
					return RC_MULTIFILEVOL;

				nVolCount++;
				bBOT = TRUE;
			}
		}
	}

	// CMTݏI
	if (m_MTDriver.WriteEnd() != 0)
		return RC_IOERROR;

	return RC_NORMAL;
}

//
//	@\	F	o̓t@C\[gpr
//
//		F	arg1 - o̓t@CP
//				arg2 - o̓t@CQ
//
//	Al	F	r
//
//	@\F	o̓t@C\[g邽߂ɔrB
//
//	l	F	
//
int COutputCMT::CompareFileName(const void *arg1, const void *arg2)
{
	char *p;
	int n1, n2;

	// t@C "n" 擾
	if ((p = strrchr((const char *)arg1, '.')) != NULL)
		n1 = atoi(p + 1);
	else
		n1 = 0;

	// t@C "n" 擾
	if ((p = strrchr((const char *)arg2, '.')) != NULL)
		n2 = atoi(p + 1);
	else
		n2 = 0;

	return n1 - n2;
}

//
//	@\	F	{[x
//
//		F	pQueue - L[
//				pVolLabel - ꂽ{[x
//
//	Al	F	{[x
//
//	@\F	J}ŋ؂ꂽ{[x𕪗B
//
//	l	F	
//
int COutputCMT::SplitVolumeLabel(Queue *pQueue, CString *pVolLabel)
{
	int i;
	CString sVolLabel;

	sVolLabel = pQueue->sVolLabel;
	for (i = 0; i < MAX_VOLUME_LABEL; i++) {
		if (sVolLabel.GetLength() == 0)
			break;

		*pVolLabel = sVolLabel.SpanExcluding(",");
		sVolLabel = sVolLabel.Mid(min((*pVolLabel).GetLength() + 1, sVolLabel.GetLength()));
		pVolLabel++;
	}

	return i;
}

//
//	@\	F	o̓t@C`FbN
//
//		F	pFileName - o̓t@C
//
//	Al	F	ȂTRUE
//
//	@\F@o̓t@C`ł邩`FbNB
//
//	l	F	
//
BOOL COutputCMT::CheckFileName(LPCTSTR pFileName)
{
	char cFileName[LEN_FILENAME];
	char *p;

	// ".n"  "." T
	strcpy(cFileName, pFileName);
	if ((p = strrchr(cFileName, '.')) == NULL)
		return FALSE;

	// n ̐`FbN
	*p = '\0';
	if (!IsNumber(p))
		return FALSE;

	// ".ubNW"  "." T
	if ((p = strrchr(cFileName, '.')) == NULL)
		return FALSE;

	// ubNW̐`FbN
	*p++ = '\0';
	if (!IsNumber(p))
		return FALSE;

	// ".R[h"  "." T
	if ((p = strrchr(cFileName, '.')) == NULL)
		return FALSE;

	// R[h̐`FbN
	*p++ = '\0';
	if (!IsNumber(p))
		return FALSE;

	return TRUE;
}

//
//	@\	F	o̓t@C͏
//
//		F	pFileName - o̓t@C
//				pFileID - t@Cʖ
//				pRecordLength - R[h
//				pBlockingFactor - ubNW
//
//	Al	F	ȂTRUE
//
//	@\F	o̓t@CɕtꂽR[hAubNWoB
//
//	l	F	
//
BOOL COutputCMT::AnalyzeFileName(LPCTSTR pFileName, CString *pFileID, int *pRecordLength, int *pBlockingFactor)
{
	char cFileName[LEN_FILENAME];
	char *p;

	// ".n"  "." T
	strcpy(cFileName, pFileName);
	if ((p = strrchr(cFileName, '.')) == NULL)
		return FALSE;

	// ".ubNW"  "." T
	*p = '\0';
	if ((p = strrchr(cFileName, '.')) == NULL)
		return FALSE;

	// ubNW̎擾
	*p++ = '\0';
	*pBlockingFactor = atoi(p);

	// ".R[h"  "." T
	if ((p = strrchr(cFileName, '.')) == NULL)
		return FALSE;

	// R[h̎擾
	*p++ = '\0';
	*pRecordLength = atoi(p);

	// t@Cʖ̎擾
	*pFileID = cFileName;

	return TRUE;
}

//
//	@\	F@`FbN
//
//		F	pNum - `FbN镶
//
//	Al	F	TRUE - OK, FALSE - NG
//
//	@\F	G[R[hƂ̓eibZ[Wj擾B
//
//	l	F	
BOOL COutputCMT::IsNumber(LPCTSTR pNum)
{
	while (*pNum != '\0') {
		if (!isdigit(*pNum++))
			return FALSE;
	}

	return TRUE;
}

//
//	@\	F@G[擾
//
//		F	nErrorCode - G[R[h
//				sErrorMsg - G[e
//
//	Al	F	
//
//	@\F	G[R[hƂ̓eibZ[Wj擾B
//
//	l	F	
//
void COutputCMT::GetError(int &nErrorCode, CString &sErrorMsg)
{
	nErrorCode = m_MTDriver.GetError(sErrorMsg);
}
